> For the complete documentation index, see [llms.txt](https://docs.uma.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.uma.xyz/developers/optimistic-oracle/using-blacklisting-tokens-as-currency.md).

# Using Blacklisting Tokens as Currency

Using a token that allows backlisting (e.g. USDC) as your [requestPrice](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L120) `currency` opens up a griefing vector that integrators should be aware of.

The [`proposePriceFor`](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L304) and [`disputePriceFor`](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L382) functions allow the caller to set any address as the `proposer` and `disputer` that will receive payouts if their proposal/dispute is correct upon settlement. If a bad actor calls both [`proposePriceFor`](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L304) and [`disputePriceFor`](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L382) and specifies a blacklisted address for repayment, the [settle](https://github.com/UMAprotocol/protocol/blob/dd9d1fa988d8520ad36db145db13591e9a104fa9/packages/core/contracts/optimistic-oracle-v2/implementation/OptimisticOracleV2.sol#L498) function will revert and cause the request to be frozen unless the address is unblacklisted. This costs the malicious user 2 bonds and does not result in any gain, but freezing the request could cause issues for the integrator.

To avoid this, integrations that use tokens with blacklisting functionality should ensure that their admins can call a function that ignores the frozen request and creates a new OOV2 request. In this way they can prevent a frozen request from having any negative consequences to their protocol.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.uma.xyz/developers/optimistic-oracle/using-blacklisting-tokens-as-currency.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
